# komga_api_client.api.OpdsControllerApi

## Load the API package
```dart
import 'package:komga_api_client/api.dart';
```

All URIs are relative to *http://localhost:8080*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getAllSeries1**](OpdsControllerApi.md#getAllSeries1) | **get** /opds/v1.2/series | 
[**getCatalog**](OpdsControllerApi.md#getCatalog) | **get** /opds/v1.2/catalog | 
[**getCollections**](OpdsControllerApi.md#getCollections) | **get** /opds/v1.2/collections | 
[**getLatestSeries1**](OpdsControllerApi.md#getLatestSeries1) | **get** /opds/v1.2/series/latest | 
[**getLibraries**](OpdsControllerApi.md#getLibraries) | **get** /opds/v1.2/libraries | 
[**getOneCollection**](OpdsControllerApi.md#getOneCollection) | **get** /opds/v1.2/collections/{id} | 
[**getOneLibrary**](OpdsControllerApi.md#getOneLibrary) | **get** /opds/v1.2/libraries/{id} | 
[**getOneSeries1**](OpdsControllerApi.md#getOneSeries1) | **get** /opds/v1.2/series/{id} | 
[**getSearch**](OpdsControllerApi.md#getSearch) | **get** /opds/v1.2/search | 


# **getAllSeries1**
> OpdsFeed getAllSeries1(search)



### Example 
```dart
import 'package:komga_api_client/api.dart';

var api_instance = new OpdsControllerApi();
var search = search_example; // String | 

try { 
    var result = api_instance.getAllSeries1(search);
    print(result);
} catch (e) {
    print("Exception when calling OpdsControllerApi->getAllSeries1: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **search** | **String**|  | [optional] [default to null]

### Return type

[**OpdsFeed**](OpdsFeed.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/xml, application/atom+xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **getCatalog**
> OpdsFeed getCatalog()



### Example 
```dart
import 'package:komga_api_client/api.dart';

var api_instance = new OpdsControllerApi();

try { 
    var result = api_instance.getCatalog();
    print(result);
} catch (e) {
    print("Exception when calling OpdsControllerApi->getCatalog: $e\n");
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**OpdsFeed**](OpdsFeed.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/xml, application/atom+xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **getCollections**
> OpdsFeed getCollections()



### Example 
```dart
import 'package:komga_api_client/api.dart';

var api_instance = new OpdsControllerApi();

try { 
    var result = api_instance.getCollections();
    print(result);
} catch (e) {
    print("Exception when calling OpdsControllerApi->getCollections: $e\n");
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**OpdsFeed**](OpdsFeed.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/xml, application/atom+xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **getLatestSeries1**
> OpdsFeed getLatestSeries1()



### Example 
```dart
import 'package:komga_api_client/api.dart';

var api_instance = new OpdsControllerApi();

try { 
    var result = api_instance.getLatestSeries1();
    print(result);
} catch (e) {
    print("Exception when calling OpdsControllerApi->getLatestSeries1: $e\n");
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**OpdsFeed**](OpdsFeed.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/xml, application/atom+xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **getLibraries**
> OpdsFeed getLibraries()



### Example 
```dart
import 'package:komga_api_client/api.dart';

var api_instance = new OpdsControllerApi();

try { 
    var result = api_instance.getLibraries();
    print(result);
} catch (e) {
    print("Exception when calling OpdsControllerApi->getLibraries: $e\n");
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**OpdsFeed**](OpdsFeed.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/xml, application/atom+xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **getOneCollection**
> OpdsFeed getOneCollection(id)



### Example 
```dart
import 'package:komga_api_client/api.dart';

var api_instance = new OpdsControllerApi();
var id = 789; // int | 

try { 
    var result = api_instance.getOneCollection(id);
    print(result);
} catch (e) {
    print("Exception when calling OpdsControllerApi->getOneCollection: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**|  | [default to null]

### Return type

[**OpdsFeed**](OpdsFeed.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/xml, application/atom+xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **getOneLibrary**
> OpdsFeed getOneLibrary(id)



### Example 
```dart
import 'package:komga_api_client/api.dart';

var api_instance = new OpdsControllerApi();
var id = 789; // int | 

try { 
    var result = api_instance.getOneLibrary(id);
    print(result);
} catch (e) {
    print("Exception when calling OpdsControllerApi->getOneLibrary: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**|  | [default to null]

### Return type

[**OpdsFeed**](OpdsFeed.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/xml, application/atom+xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **getOneSeries1**
> OpdsFeed getOneSeries1(id, userAgent)



### Example 
```dart
import 'package:komga_api_client/api.dart';

var api_instance = new OpdsControllerApi();
var id = 789; // int | 
var userAgent = userAgent_example; // String | 

try { 
    var result = api_instance.getOneSeries1(id, userAgent);
    print(result);
} catch (e) {
    print("Exception when calling OpdsControllerApi->getOneSeries1: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**|  | [default to null]
 **userAgent** | **String**|  | [optional] [default to &quot;&quot;]

### Return type

[**OpdsFeed**](OpdsFeed.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/xml, application/atom+xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **getSearch**
> OpenSearchDescription getSearch()



### Example 
```dart
import 'package:komga_api_client/api.dart';

var api_instance = new OpdsControllerApi();

try { 
    var result = api_instance.getSearch();
    print(result);
} catch (e) {
    print("Exception when calling OpdsControllerApi->getSearch: $e\n");
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**OpenSearchDescription**](OpenSearchDescription.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/xml, application/atom+xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

