# komga_api_client.api.SeriesCollectionControllerApi

## Load the API package
```dart
import 'package:komga_api_client/api.dart';
```

All URIs are relative to *http://localhost:8080*

Method | HTTP request | Description
------------- | ------------- | -------------
[**addOne1**](SeriesCollectionControllerApi.md#addOne1) | **post** /api/v1/collections | 
[**deleteOne1**](SeriesCollectionControllerApi.md#deleteOne1) | **delete** /api/v1/collections/{id} | 
[**getAll1**](SeriesCollectionControllerApi.md#getAll1) | **get** /api/v1/collections | 
[**getCollectionThumbnail**](SeriesCollectionControllerApi.md#getCollectionThumbnail) | **get** /api/v1/collections/{id}/thumbnail | 
[**getOne1**](SeriesCollectionControllerApi.md#getOne1) | **get** /api/v1/collections/{id} | 
[**getSeriesForCollection**](SeriesCollectionControllerApi.md#getSeriesForCollection) | **get** /api/v1/collections/{id}/series | 
[**updateOne**](SeriesCollectionControllerApi.md#updateOne) | **patch** /api/v1/collections/{id} | 


# **addOne1**
> CollectionDto addOne1(collectionCreationDto)



### Example 
```dart
import 'package:komga_api_client/api.dart';

var api_instance = new SeriesCollectionControllerApi();
var collectionCreationDto = new CollectionCreationDto(); // CollectionCreationDto | 

try { 
    var result = api_instance.addOne1(collectionCreationDto);
    print(result);
} catch (e) {
    print("Exception when calling SeriesCollectionControllerApi->addOne1: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **collectionCreationDto** | [**CollectionCreationDto**](CollectionCreationDto.md)|  | 

### Return type

[**CollectionDto**](CollectionDto.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **deleteOne1**
> deleteOne1(id)



### Example 
```dart
import 'package:komga_api_client/api.dart';

var api_instance = new SeriesCollectionControllerApi();
var id = 789; // int | 

try { 
    api_instance.deleteOne1(id);
} catch (e) {
    print("Exception when calling SeriesCollectionControllerApi->deleteOne1: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**|  | [default to null]

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **getAll1**
> PageCollectionDto getAll1(search, libraryId, unpaged, page, size)



### Example 
```dart
import 'package:komga_api_client/api.dart';

var api_instance = new SeriesCollectionControllerApi();
var search = search_example; // String | 
var libraryId = []; // List<int> | 
var unpaged = true; // bool | 
var page = 56; // int | Zero-based page index (0..N)
var size = 56; // int | The size of the page to be returned

try { 
    var result = api_instance.getAll1(search, libraryId, unpaged, page, size);
    print(result);
} catch (e) {
    print("Exception when calling SeriesCollectionControllerApi->getAll1: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **search** | **String**|  | [optional] [default to null]
 **libraryId** | [**List&lt;int&gt;**](int.md)|  | [optional] [default to const []]
 **unpaged** | **bool**|  | [optional] [default to null]
 **page** | **int**| Zero-based page index (0..N) | [optional] [default to null]
 **size** | **int**| The size of the page to be returned | [optional] [default to null]

### Return type

[**PageCollectionDto**](PageCollectionDto.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **getCollectionThumbnail**
> Uint8List getCollectionThumbnail(id)



### Example 
```dart
import 'package:komga_api_client/api.dart';

var api_instance = new SeriesCollectionControllerApi();
var id = 789; // int | 

try { 
    var result = api_instance.getCollectionThumbnail(id);
    print(result);
} catch (e) {
    print("Exception when calling SeriesCollectionControllerApi->getCollectionThumbnail: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**|  | [default to null]

### Return type

[**Uint8List**](Uint8List.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: image/jpeg

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **getOne1**
> CollectionDto getOne1(id)



### Example 
```dart
import 'package:komga_api_client/api.dart';

var api_instance = new SeriesCollectionControllerApi();
var id = 789; // int | 

try { 
    var result = api_instance.getOne1(id);
    print(result);
} catch (e) {
    print("Exception when calling SeriesCollectionControllerApi->getOne1: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**|  | [default to null]

### Return type

[**CollectionDto**](CollectionDto.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **getSeriesForCollection**
> PageSeriesDto getSeriesForCollection(id, unpaged, page, size)



### Example 
```dart
import 'package:komga_api_client/api.dart';

var api_instance = new SeriesCollectionControllerApi();
var id = 789; // int | 
var unpaged = true; // bool | 
var page = 56; // int | Zero-based page index (0..N)
var size = 56; // int | The size of the page to be returned

try { 
    var result = api_instance.getSeriesForCollection(id, unpaged, page, size);
    print(result);
} catch (e) {
    print("Exception when calling SeriesCollectionControllerApi->getSeriesForCollection: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**|  | [default to null]
 **unpaged** | **bool**|  | [optional] [default to null]
 **page** | **int**| Zero-based page index (0..N) | [optional] [default to null]
 **size** | **int**| The size of the page to be returned | [optional] [default to null]

### Return type

[**PageSeriesDto**](PageSeriesDto.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **updateOne**
> updateOne(id, collectionUpdateDto)



### Example 
```dart
import 'package:komga_api_client/api.dart';

var api_instance = new SeriesCollectionControllerApi();
var id = 789; // int | 
var collectionUpdateDto = new CollectionUpdateDto(); // CollectionUpdateDto | 

try { 
    api_instance.updateOne(id, collectionUpdateDto);
} catch (e) {
    print("Exception when calling SeriesCollectionControllerApi->updateOne: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**|  | [default to null]
 **collectionUpdateDto** | [**CollectionUpdateDto**](CollectionUpdateDto.md)|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

