            import 'package:komga_api_client/model/opds_author.dart';
            import 'package:komga_api_client/model/opds_link.dart';
            import 'package:built_collection/built_collection.dart';
            import 'package:time_machine/time_machine.dart';
            import 'package:komga_api_client/model/opds_entry.dart';
        import 'package:built_value/built_value.dart';
import 'package:built_value/serializer.dart';

part 'opds_feed.g.dart';

abstract class OpdsFeed implements Built<OpdsFeed, OpdsFeedBuilder> {

    
        @nullable
    @BuiltValueField(wireName: r'entries')
    BuiltList<OpdsEntry> get entries;
    
        @nullable
    @BuiltValueField(wireName: r'author')
    OpdsAuthor get author;
    
        @nullable
    @BuiltValueField(wireName: r'links')
    BuiltList<OpdsLink> get links;
    
        @nullable
    @BuiltValueField(wireName: r'id')
    String get id;
    
        @nullable
    @BuiltValueField(wireName: r'title')
    String get title;
    
        @nullable
    @BuiltValueField(wireName: r'updated')
    OffsetDateTime get updated;

    // Boilerplate code needed to wire-up generated code
    OpdsFeed._();

    factory OpdsFeed([updates(OpdsFeedBuilder b)]) = _$OpdsFeed;
    static Serializer<OpdsFeed> get serializer => _$opdsFeedSerializer;

}

