            import 'package:komga_api_client/model/pageable.dart';
            import 'package:komga_api_client/model/sort.dart';
            import 'package:built_collection/built_collection.dart';
            import 'package:komga_api_client/model/collection_dto.dart';
        import 'package:built_value/built_value.dart';
import 'package:built_value/serializer.dart';

part 'page_collection_dto.g.dart';

abstract class PageCollectionDto implements Built<PageCollectionDto, PageCollectionDtoBuilder> {

    
        @nullable
    @BuiltValueField(wireName: r'number')
    int get number;
    
        @nullable
    @BuiltValueField(wireName: r'last')
    bool get last;
    
        @nullable
    @BuiltValueField(wireName: r'numberOfElements')
    int get numberOfElements;
    
        @nullable
    @BuiltValueField(wireName: r'size')
    int get size;
    
        @nullable
    @BuiltValueField(wireName: r'totalPages')
    int get totalPages;
    
        @nullable
    @BuiltValueField(wireName: r'pageable')
    Pageable get pageable;
    
        @nullable
    @BuiltValueField(wireName: r'sort')
    Sort get sort;
    
        @nullable
    @BuiltValueField(wireName: r'first')
    bool get first;
    
        @nullable
    @BuiltValueField(wireName: r'content')
    BuiltList<CollectionDto> get content;
    
        @nullable
    @BuiltValueField(wireName: r'totalElements')
    int get totalElements;
    
        @nullable
    @BuiltValueField(wireName: r'empty')
    bool get empty;

    // Boilerplate code needed to wire-up generated code
    PageCollectionDto._();

    factory PageCollectionDto([updates(PageCollectionDtoBuilder b)]) = _$PageCollectionDto;
    static Serializer<PageCollectionDto> get serializer => _$pageCollectionDtoSerializer;

}

